//
// A score record JavaScript class to store the name and the score of a player
//
function ScoreRecord(name, score) {
    this.name = name;
    this.score = score;
}


//
// This function reads the high score table from the cookies
//
function getHighScoreTable() {
    var table = new Array();
	console.log("newed table",table);
    for (var i = 0; i < 10; i++) {
        // Contruct the cookie name
		var cname = "player"+i;
        // Get the cookie value using the cookie name
		var cookie = getCookie(cname);
		console.log("getCookie("+cname+")",cookie);
        // If the cookie does not exist exit from the for loop
		if (cookie==null)break;
        // Extract the name and score of the player from the cookie value
		var pnamescore = cookie.split("~")
        // Add a new score record at the end of the array
		table.push(new ScoreRecord(pnamescore[0], pnamescore[1]));
    }

    return table;
}


//
// This function stores the high score table to the cookies
//
function setHighScoreTable(table) {
	for (var i = 0; i < 10; i++) {
		// If i is more than the length of the table exit from the for loop
		if (i >= table.length) break;
		// Construct the cookie name
		var cname = "player"+i;
		// Store the ith record as a cookie using the cookie name
		var now = new Date();
		now.setTime(now.getTime() + 1 * 24 * 60 * 60 * 1000);
		setCookie(cname,table[i].name+"~"+table[i].score,now);
	}
}


//
// This function adds a high score entry to the text node
//
function addHighScore(record, node, color) {
    // Create the name text span
    var name = svgdoc.createElementNS("http://www.w3.org/2000/svg", "tspan");
	console.log("addHighScore record",record);
    // Set the attributes and create the text
	name.setAttribute("x","100");
	name.setAttribute("dy","30");
	name.innerHTML = record.name;
	name.setAttribute("style", "fill:" + color);
    // Add the name to the text node
	//svgdoc.getElementById("highscoretable").appendChild(name);
	node.appendChild(name);
    // Create the score text span
    var score = svgdoc.createElementNS("http://www.w3.org/2000/svg", "tspan");

    // Set the attributes and create the text
	score.setAttribute("x","400");
	score.setAttribute("style", "fill:" + color);
    // Add the name to the text node
	score.textContent = record.score;
	//svgdoc.getElementById("highscoretable").appendChild(score);
	node.appendChild(score);
}


//
// This function shows the high score table to SVG
//
function showHighScoreTable(table, index) {
    // Show the table
    var node = svgdoc.getElementById("highscoretable");
	node.setAttribute("visibility","visible");

    // Get the high score text node
    var node = svgdoc.getElementById("highscoretext");

    for (var i = 0; i < 10; i++) {
        // If i is more than the length of the high score table exit
        // from the for loop
        if (i >= table.length) break;

        // Add the record at the end of the text node
        addHighScore(table[i], node, (index == i ? "blue" : "white"));
    }
}


//
// The following functions are used to handle HTML cookies
//

//
// Set a cookie
//
function setCookie(name, value, expires, path, domain, secure) {
    var curCookie = name + "=" + escape(value) +
        ((expires) ? "; expires=" + expires.toGMTString() : "") +
        ((path) ? "; path=" + path : "") +
        ((domain) ? "; domain=" + domain : "") +
        ((secure) ? "; secure" : "");
    document.cookie = curCookie;
}


//
// Get a cookie
//
function getCookie(name) {
    var dc = document.cookie;
    var prefix = name + "=";
    var begin = dc.indexOf("; " + prefix);
    if (begin == -1) {
        begin = dc.indexOf(prefix);
        if (begin != 0) return null;
    } else
        begin += 2;
    var end = document.cookie.indexOf(";", begin);
    if (end == -1)
        end = dc.length;
    return unescape(dc.substring(begin + prefix.length, end));
}


//
// Delete a cookie
//
function deleteCookie(name, path, domain) {
    if (get_cookie(name)) {
        document.cookie = name + "=" +
        ((path) ? "; path=" + path : "") +
        ((domain) ? "; domain=" + domain : "") +
        "; expires=Thu, 01-Jan-70 00:00:01 GMT";
    }
}
